&routine extend

&rem **** define variables and initialize


&define x1 -1 &var
&define y1 -2 &var
&define x2 -3 &var
&define y2 -4 &var
&define df -5 &var
&define dt -6 &var
&define coo -12 &var
&define snapt -13 &var
&define nod_t -14 &var
&define int_f -15 &var
&define int_t -16 &var
&define int_s -17 &var
&define temp -19 &var
&define arc_f 2 &var
&define arc_t 3 &var
&define min_x 4 &var
&define min_y 5 &var
&define max_x 6 &var
&define max_y 7  &var

SHOW COO [coo]
SHOW SNAPT [snapt]
SHOW SELECT 1 [arc_f]
SHOW ARC %[arc_f] NPNTS [nod_t]
SHOW MAPEXTENT [min_x] [min_y] [max_x] [max_y]

&rem **** select to_arc

SEL $RECNO IN {[arc_f]}
V DRAW
&type "SELECT ARC TO EXTEND TO:"
SEL MANY
WIN FOCUS T
SHOW NUMBER SELECT [temp]
&if &ne [temp] 1 &do
   SEL $RECNO in {[arc_f]}
   &return
&end
SHOW SELECT 1 [arc_t]
&if &eq [arc_f] [arc_t] &do
   WIN MB 1 'Cannot extend arc to self.'
   &return
&end

&rem **** find intersection(s)

&r intersec 1
&rv [int_f]
&r intersec [nod_t]
&rv [int_t]
&if &eq "[int_f]" "NO" &and &eq "[int_t]" "NO" &do
   &type "No intersections within current mapextent."
   SEL $RECNO in {[arc_f]}
   &return
&end

&rem **** check for identical intersection point

&sv [int_s] .FALSE.
&if &ne "NO" "[int_f]" &and &ne "NO" "[int_t]" &do
   &extract [x1] [int_f] 1
   &extract [y1] [int_f] 2
   &extract [x2] [int_t] 1
   &extract [y2] [int_t] 2
   &if &eq %<[x1] - [x2] + [y1] - [y2]> 0 &do
      &sv [int_s] .TRUE.
   &end
&end

&rem **** create split(s)

COO KEY
&if &eq [int_s] .TRUE. &do
   SPLIT
   1 [int_f]
&elseif &ne "NO" "[int_f]" &do
   SPLIT
   1 [int_f]
   &if &ne "NO" "[int_t]" &do
      SHOW NUMBER SELECT [temp]
      &if &ne [temp] 2 &do
         &rem **** recover from bad split
         SEL $RECNO in {[arc_t]}
      &end
      RES
      1 [int_t]
      SPLIT
      1 [int_t]
   &end
&else
   SPLIT
   1 [int_t]
&end

&rem **** move node(s) to intersection point(s)

SEL $RECNO in {[arc_f]}
SNAPT CLOSEST
&if &eq [int_s] .TRUE. &and &eq [nod_t] 2 &do

   &rem **** find closest node

   &extract [x2] [int_t] 1
   &extract [y2] [int_t] 2
   SHOW ARC %[arc_f] VERTEX 1 [x1] [y1]
   &cv [x1] [x2] - [x1]
   &cv [y1] [y2] - [y1]
   &cv [df] ( [x1] * [x1] ) + ( [y1] * [y1] )
   SHOW ARC %[arc_f] VERTEX %[nod_t] [x1] [y1]
   &cv [x1] [x2] - [x1]
   &cv [y1] [y2] - [y1]
   &cv [dt] ( [x1] * [x1] ) + ( [y1] * [y1] )
   &if &eq %<[df] min [dt]> [df] &do
      V MOVE 1
      1 [int_f]
   &else
      V MOVE [nod_t]
      1 [int_t]
   &end
&else
   &if &ne "[int_f]" "NO" &do
      V MOVE 1
      1 [int_f]
   &end
   &if &ne "[int_t]" "NO" &do
      V MOVE [nod_t]
      1 [int_t]
   &end
&end

&rem **** snap arc into place

MOVE
1 0 0
1 0 0
DRAWSELECT
COO [coo]
SNAPT [snapt]
&return

&routine intersec

&rem **** define variables and initialize

&define A -1 &var
&define B -2 &var
&define C -3 &var
&define D -4 &var
&define E -5 &var
&define F -6 &var
&define x5 -7 &var
&define y5 -8 &var
&define intersect -9 &var
&define numv -10 &var
&define x1 -11 &var
&define x2 -12 &var
&define x3 -13 &var
&define x4 -14 &var
&define y1 -15 &var
&define y2 -16 &var
&define y3 -17 &var
&define y4 -18 &var
&define temp -19 &var
&define arc_f 2 &var
&define arc_t 3 &var
&define min_x 4 &var
&define min_y 5 &var
&define max_x 6 &var
&define max_y 7  &var
&define i 8 &var
&define distance 9 &var

&rem **** set x1 and y1 values

&if &eq %-1 1 &do
   SHOW ARC %[arc_f] VERTEX 2 [x1] [y1]
   SHOW ARC %[arc_f] VERTEX 1 [x2] [y2]
&else
   SHOW ARC %[arc_f] VERTEX %<%-1 - 1> [x1] [y1]
   SHOW ARC %[arc_f] VERTEX %-1 [x2] [y2]
&end

&rem **** search TO arc segments for closest suitable intersection

&sv [intersect] NO
&sv [distance] -1
SHOW ARC %[arc_t] NPNTS [numv]
&cv [numv] [numv] - 1
&sv [i] 1
&while &rn [i] 1 [numv] &do
   SHOW ARC %[arc_t] VERTEX %[i] [x3] [y3]
   SHOW ARC %[arc_t] VERTEX %<[i] + 1> [x4] [y4]
   &cv [A] [x2] - [x1]
   &cv [B] [y2] - [y1]
   &cv [C] [x3] - [x1]
   &cv [D] [y3] - [y1]
   &cv [E] [x4] - [x3]
   &cv [F] [y4] - [y3]

   &rem **** check for parallel segments

   &if &eq %<( [A] * [F] ) - ( [B] * [E] )> 0 &do
      &inc [i]
      &continue
   &end

   &rem **** find "universal" intersect point

   &cv [temp] [A] * ( ( [C] * [F] ) - ( [D] * [E] ) ) / ( ( [A] * [F] ) - ( [B] * [E] ) )
   &cv [x5] [x1] + [temp]
   &cv [temp] [B] * ( ( [C] * [F] ) - ( [D] * [E] ) ) / ( ( [A] * [F] ) - ( [B] * [E] ) )
   &cv [y5] [y1] + [temp]

   &rem **** check if point is outside of mapextent

   &if &nr [x5] [min_x] [max_x] &or &nr [y5] [min_y] [max_y] &do
      &inc [i]
      &continue
   &end

   &rem **** check if point is not on segment

   &if &nr [x5] %<[x3] min [x4]> %<[x3] max [x4]> &do
      &inc [i]
      &continue
   &end
   &if &nr [y5] %<[y3] min [y4]> %<[y3] max [y4]> &do
      &inc [i]
      &continue
   &end

   &rem **** check direction

   &if &nr [x2] %<[x1] min [x5]> %<[x1] max [x5]> &do
      &if &nr [x5] %<[x1] min [x2]> %<[x1] max [x2]> &do
         &inc [i]
         &continue
      &end
   &end
   &if &nr [y2] %<[y1] min [y5]> %<[y1] max [y5]> &do
      &if &nr [y5] %<[y1] min [y2]> %<[y1] max [y2]> &do
         &inc [i]
         &continue
      &end
   &end

   &rem **** check for closest intersection

   &cv [A] [x5] - [x2]
   &cv [B] [y5] - [y2]
   &cv [D] ( [A] * [A] ) + ( [B] * [B] )
   &if &eq [distance] -1 &or &eq %<[D] min [distance]> [D] &do
      &sv [intersect] "[x5] [y5]"
      &value [distance] [D]
   &end
   &inc [i]
&end
&return "[intersect]"

